/*!
 * HTML Parser By John Resig (ejohn.org)
 * Original code by Erik Arvidsson, Mozilla Public License
 * http://erik.eae.net/simplehtmlparser/simplehtmlparser.js
 *
 * // Use like so:
 * HTMLParser(htmlString, {
 *     start: function(tag, attrs, unary) {},
 *     end: function(tag) {},
 *     chars: function(text) {},
 *     comment: function(text) {}
 * });
 *
 * // or to get an XML string:
 * HTMLtoXML(htmlString);
 *
 * // or to get an XML DOM Document
 * HTMLtoDOM(htmlString);
 *
 * // or to inject into an existing document/DOM node
 * HTMLtoDOM(htmlString, document);
 * HTMLtoDOM(htmlString, document.body);
 *
 */
!function(){function a(a){for(var b={},c=a.split(","),d=0;d<c.length;d++)b[c[d]]=!0;return b}var b=/^<([-A-Za-z0-9_]+)((?:\s+[a-zA-Z_:][-a-zA-Z0-9_:.]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)>/,c=/^<\/([-A-Za-z0-9_]+)[^>]*>/,d=/([a-zA-Z_:][-a-zA-Z0-9_:.]+)(?:\s*=\s*(?:(?:"((?:\\.|[^"])*)")|(?:'((?:\\.|[^'])*)')|([^>\s]+)))?/g,e=a("area,base,basefont,br,col,frame,hr,img,input,isindex,link,meta,param,embed"),f=a("address,applet,blockquote,button,center,dd,del,dir,div,dl,dt,fieldset,form,frameset,hr,iframe,ins,isindex,li,map,menu,noframes,noscript,object,ol,p,pre,script,table,tbody,td,tfoot,th,thead,tr,ul"),g=a("a,abbr,acronym,applet,b,basefont,bdo,big,br,button,cite,code,del,dfn,em,font,i,iframe,img,input,ins,kbd,label,map,object,q,s,samp,script,select,small,span,strike,strong,sub,sup,textarea,tt,u,var"),h=a("colgroup,dd,dt,li,options,p,td,tfoot,th,thead,tr"),i=a("checked,compact,declare,defer,disabled,ismap,multiple,nohref,noresize,noshade,nowrap,readonly,selected"),j=a("script,style"),k=this.HTMLParser=function(a,k){function l(a,b,c,j){if(b=b.toLowerCase(),f[b])for(;q.last()&&g[q.last()];)m("",q.last());if(h[b]&&q.last()==b&&m("",b),j=e[b]||!!j,j||q.push(b),k.start){var l=[];c.replace(d,function(a,b){var c=arguments[2]?arguments[2]:arguments[3]?arguments[3]:arguments[4]?arguments[4]:i[b]?b:"";l.push({name:b,value:c,escaped:c.replace(/(^|[^\\])"/g,'$1\\"')})}),k.start&&k.start(b,l,j)}}function m(a,b){if(b)for(var c=q.length-1;c>=0&&q[c]!=b;c--);else var c=0;if(c>=0){for(var d=q.length-1;d>=c;d--)k.end&&k.end(q[d]);q.length=c}}var n,o,p,q=[],r=a;for(q.last=function(){return this[this.length-1]};a;){if(o=!0,q.last()&&j[q.last()])a=a.replace(new RegExp("([.|\\w|\\W]*)</"+q.last()+"[^>]*>","im"),function(a,b){return b=b.replace(/<!--(.*?)-->/g,"$1").replace(/<!\[CDATA\[(.*?)]]>/g,"$1"),k.chars&&k.chars(b),""}),m("",q.last());else if(0==a.indexOf("<!--")?(n=a.indexOf("-->"),n>=0&&(k.comment&&k.comment(a.substring(4,n)),a=a.substring(n+3),o=!1)):0==a.indexOf("<?php")?(n=a.indexOf("?>"),n>=0&&(k.php&&k.php(a.substring(5,n)),a=a.substring(n+2),o=!1)):0==a.indexOf("</")?(p=a.match(c),p&&(a=a.substring(p[0].length),p[0].replace(c,m),o=!1)):a.search(/<($|\s)/i)>-1?(k.chars(a),a=""):0==a.indexOf("<")&&(p=a.match(b),p&&(a=a.substring(p[0].length),p[0].replace(b,l),o=!1)),o){n=a.indexOf("<");var s=0>n?a:a.substring(0,n);a=0>n?"":a.substring(n),k.chars&&k.chars(s)}if(a==r)throw alert("Sorry, it seems that you've entered malformed HTML.\n\nPlease verify that the code you entered is valid and try again.\n\nEnsure you are only using HTML form code and do not use javascript as it is not supported in this field."),"Parse Error: "+a;r=a}m()};this.HTMLtoXML=function(a){var b="";return k(a,{start:function(a,c,d){b+="<"+a;for(var e=0;e<c.length;e++)b+=" "+c[e].name+'="'+c[e].escaped+'"';b+=(d?"/":"")+">"},end:function(a){b+="</"+a+">"},chars:function(a){b+=a},comment:function(a){b+="<!--"+a+"-->"},php:function(a){b+="<?php"+a+"?>"}}),b},this.HTMLtoDOM=function(b,c){var d=a("html,head,body,title"),e={link:"head",base:"head"};c?c=c.ownerDocument||c.getOwnerDocument&&c.getOwnerDocument()||c:"undefined"!=typeof DOMDocument?c=new DOMDocument:"undefined"!=typeof document&&document.implementation&&document.implementation.createDocument?c=document.implementation.createDocument("","",null):"undefined"!=typeof ActiveX&&(c=new ActiveXObject("Msxml.DOMDocument"));var f=[],g=c.documentElement||c.getDocumentElement&&c.getDocumentElement();if(!g&&c.createElement&&function(){var a=c.createElement("html"),b=c.createElement("head");b.appendChild(c.createElement("title")),a.appendChild(b),a.appendChild(c.createElement("body")),c.appendChild(a)}(),c.getElementsByTagName)for(var h in d)d[h]=c.getElementsByTagName(h)[0];var i=d.body;return k(b,{start:function(a,b,g){if(d[a])return i=d[a],void(g||f.push(i));var h=c.createElement(a);for(var j in b)h.setAttribute(b[j].name,b[j].value);e[a]&&"boolean"!=typeof d[e[a]]?d[e[a]].appendChild(h):i&&i.appendChild&&i.appendChild(h),g||(f.push(h),i=h)},end:function(a){f.length-=1,i=f[f.length-1]},chars:function(a){i.appendChild(c.createTextNode(a))},comment:function(a){}}),c}}();